﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Namespace TestClasses
    Public Class Car
        Implements INotifyPropertyChanged

        Private _brand As String

        Public Property Brand() As String
            Get
                Return _brand
            End Get
            Set(ByVal value As String)
                _brand = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _model As String

        Public Property Model() As String
            Get
                Return _model
            End Get
            Set(ByVal value As String)
                _model = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _power As Integer

        Public Property Power() As Integer
            Get
                Return _power
            End Get
            Set(ByVal value As Integer)
                _power = value
                RaisePropertyChanged()
            End Set
        End Property






        Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
        End Sub

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    End Class
End Namespace